/*
 *  Interface for a GGstInputStream factory
 *
 *  Copyright (C) 2008 W. Michael Petullo <mike@flyn.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef __G_GST_MP3_INPUT_STREAM_FACTORY_H
#define __G_GST_MP3_INPUT_STREAM_FACTORY_H

#include <glib-object.h>

#include "g-gst-input-stream-factory.h"

G_BEGIN_DECLS

#define TYPE_G_GST_MP3_INPUT_STREAM_FACTORY (g_gst_mp3_input_stream_factory_get_type ())
#define G_GST_MP3_INPUT_STREAM_FACTORY(o)	 (G_TYPE_CHECK_INSTANCE_CAST ((o), \
				  TYPE_G_GST_MP3_INPUT_STREAM_FACTORY, GGstMP3InputStreamFactory))
#define G_GST_MP3_INPUT_STREAM_FACTORY_CLASS(k)(G_TYPE_CHECK_INSTANCE_TYPE ((k), \
				  TYPE_G_GST_MP3_INPUT_STREAM_FACTORY, GGstMP3InputStreamFactoryClass))
#define IS_G_GST_MP3_INPUT_STREAM_FACTORY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), \
						TYPE_G_GST_MP3_INPUT_STREAM_FACTORY))
#define IS_G_GST_MP3_INPUT_STREAM_FACTORY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), \
						TYPE_G_GST_MP3_INPUT_STREAM_FACTORY_CLASS))
#define G_GST_MP3_INPUT_STREAM_FACTORY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), \
							TYPE_G_GST_MP3_INPUT_STREAM_FACTORY, GGstMP3InputStreamFactory))

typedef struct GGstMP3InputStreamFactoryPrivate GGstMP3InputStreamFactoryPrivate;

typedef struct {
	GObject parent;
} GGstMP3InputStreamFactory;

typedef struct {
        GObjectClass parent;
} GGstMP3InputStreamFactoryClass;

GType g_gst_mp3_input_stream_factory_get_type (void);

GGstMP3InputStreamFactory *g_gst_mp3_input_stream_factory_new (void);

GGstInputStream *g_gst_mp3_input_stream_factory_create (GGstInputStreamFactory *factory, const char *location);

#endif /* __G_GST_MP3_INPUT_STREAM_FACTORY_H */

G_END_DECLS
