/*
 *  Interface for a GGstInputStream factory
 *
 *  Copyright (C) 2008 W. Michael Petullo <mike@flyn.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "g-gst-raw-input-stream-factory.h"
#include "g-gst-raw-input-stream.h"

static void
g_gst_raw_input_stream_factory_init (GGstRAWInputStreamFactory *factory)
{
}

static void
g_gst_raw_input_stream_factory_class_init (GGstRAWInputStreamFactoryClass *class)
{
}

static void
g_gst_raw_input_stream_factory_interface_init (gpointer iface, gpointer data)
{
	GGstInputStreamFactoryInterface *factory = iface;

	g_assert (G_TYPE_FROM_INTERFACE (factory) == TYPE_G_GST_INPUT_STREAM_FACTORY);

	factory->create = g_gst_raw_input_stream_factory_create;
}

GGstInputStream *
g_gst_raw_input_stream_factory_create (GGstInputStreamFactory *factory, const char *location)
{
	return G_GST_INPUT_STREAM (g_gst_raw_input_stream_new (location));
}

G_DEFINE_TYPE_WITH_CODE (GGstRAWInputStreamFactory, g_gst_raw_input_stream_factory, G_TYPE_OBJECT,
                         G_IMPLEMENT_INTERFACE (TYPE_G_GST_INPUT_STREAM_FACTORY,
                                                g_gst_raw_input_stream_factory_interface_init))

GGstRAWInputStreamFactory *
g_gst_raw_input_stream_factory_new (void)
{
	return G_GST_RAW_INPUT_STREAM_FACTORY (g_object_new (TYPE_G_GST_RAW_INPUT_STREAM_FACTORY, NULL));
}
